<template>
  <div class="ele-body">
    <a-card :bordered="false">
      <!-- 表格 -->
      <ele-pro-table
        ref="tableRef"
        row-key="categoryId"
        :columns="columns"
        :datasource="datasource"
        :parse-data="parseData"
        :need-page="false"
        :customRow="customRow"
        :expand-icon-column-index="1"
        :expanded-row-keys="expandedRowKeys"
        :scroll="{ x: 1200 }"
        cache-key="proArticleCategoryTable"
        @done="onDone"
        @expand="onExpand"
      >
        <template #toolbar>
          <a-space>
            <a-button type="primary" class="ele-btn-icon" @click="openEdit()">
              <template #icon>
                <plus-outlined />
              </template>
              <span>新建</span>
            </a-button>
            <a-button type="dashed" class="ele-btn-icon" @click="expandAll">
              展开全部
            </a-button>
            <a-button type="dashed" class="ele-btn-icon" @click="foldAll">
              折叠全部
            </a-button>
            <!-- 搜索表单 -->
            <a-input-search
              allow-clear
              v-model:value="searchText"
              placeholder="请输入搜索关键词"
              @search="reload"
              @pressEnter="reload"
            />
          </a-space>
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'path'">
            <span class="ele-text-placeholder">{{ record.path }}</span>
          </template>
          <template v-if="column.key === 'component'">
            <span class="ele-text-placeholder">{{ record.component }}</span>
          </template>
          <template v-if="column.key === 'type'">
            <a-tag v-if="isExternalLink(record.path)" color="red">外链</a-tag>
            <a-tag v-else-if="isExternalLink(record.component)" color="orange">
              内链
            </a-tag>
            <a-tag v-else-if="isDirectory(record)" color="blue">目录</a-tag>
            <a-tag v-else-if="record.type === 0">列表</a-tag>
            <a-tag v-else-if="record.type === 1" color="purple">页面</a-tag>
            <a-tag v-else-if="record.type === 2" color="orange">链接</a-tag>
          </template>
          <template v-else-if="column.key === 'title'">
            <a-avatar
              :size="22"
              shape="square"
              :src="`${record.image}`"
              style="margin-right: 10px"
              v-if="record.image"
            />
            <a
              @click="
                openPreview(
                  `https://${record.tenantId}.wsdns.cn/article/` +
                    record.categoryId
                )
              "
              >{{ record.title }}</a
            >
          </template>
          <template v-if="column.key === 'showIndex'">
            <a-space @click="onShowIndex(record)">
              <span v-if="record.showIndex === 1" class="ele-text-success"
                ><CheckOutlined
              /></span>
              <span v-else class="ele-text-placeholder"><CloseOutlined /></span>
            </a-space>
          </template>
          <template v-if="column.key === 'recommend'">
            <a-space @click="onRecommend(record)">
              <span v-if="record.recommend === 1" class="ele-text-success"
                ><CheckOutlined
              /></span>
              <span v-else class="ele-text-placeholder"><CloseOutlined /></span>
            </a-space>
          </template>
          <template v-if="column.key === 'status'">
            <a-tag v-if="record.status === 0" color="green">显示</a-tag>
            <a-tag v-if="record.status === 1" color="orange">隐藏</a-tag>
          </template>
          <template v-else-if="column.key === 'action'">
            <a-space>
              <a @click="openEdit(null, record.categoryId)">添加</a>
              <a-divider type="vertical" />
              <a @click="moveUp(record)">上移<ArrowUpOutlined /></a>
              <a-divider type="vertical" />
              <a @click="openEdit(record)">修改</a>
              <a-divider type="vertical" />
              <a-popconfirm
                placement="topRight"
                title="确定要删除此分类吗？"
                @confirm="remove(record)"
              >
                <a class="ele-text-danger">删除</a>
              </a-popconfirm>
            </a-space>
          </template>
        </template>
      </ele-pro-table>
    </a-card>
    <!-- 编辑弹窗 -->
    <category-edit
      v-model:visible="showEdit"
      :data="current"
      :parent-id="parentId"
      :category-list="categoryData"
      @done="reload"
    />
  </div>
</template>

<script lang="ts" setup>
  import { ref } from 'vue';
  import { message } from 'ant-design-vue/es';
  import {
    ArrowUpOutlined,
    PlusOutlined,
    CheckOutlined,
    CloseOutlined
  } from '@ant-design/icons-vue';
  import type {
    DatasourceFunction,
    ColumnItem,
    EleProTableDone
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import {
    messageLoading,
    toDateString,
    isExternalLink,
    toTreeData,
    eachTreeData
  } from 'ele-admin-pro/es';
  import type { EleProTable } from 'ele-admin-pro/es';
  import CategoryEdit from './components/category-edit.vue';
  import {
    listArticleCategory,
    removeArticleCategory,
    updateArticleCategory
  } from '@/api/cms/category';
  import type {
    ArticleCategory,
    ArticleCategoryParam
  } from '@/api/cms/category/model';
  import { openNew, openPreview } from '@/utils/common';
  import { getSiteInfo } from '@/api/layout';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      dataIndex: 'categoryId',
      width: 80
    },
    {
      title: '分类名称',
      dataIndex: 'title',
      key: 'title',
      showSorterTooltip: false,
      ellipsis: true
    },
    // {
    //   title: '路由地址',
    //   dataIndex: 'path',
    //   key: 'path'
    // },
    // {
    //   title: '组件路径',
    //   dataIndex: 'component',
    //   key: 'component'
    // },
    // {
    //   title: '类型',
    //   dataIndex: 'type',
    //   key: 'type',
    //   align: 'center',
    //   width: 120
    // },
    {
      title: '首页显示',
      dataIndex: 'showIndex',
      key: 'showIndex',
      align: 'center',
      width: 120,
      hideInTable: false
    },
    {
      title: '推荐',
      dataIndex: 'recommend',
      key: 'recommend',
      align: 'center',
      width: 120,
      hideInTable: false
    },
    {
      title: '排序',
      dataIndex: 'sortNumber',
      align: 'center',
      width: 120,
      showSorterTooltip: false
    },
    {
      title: '状态',
      dataIndex: 'status',
      key: 'status',
      align: 'center',
      width: 120,
      showSorterTooltip: false,
      customRender: ({ text }) => ['显示', '隐藏'][text]
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      showSorterTooltip: false,
      ellipsis: true,
      width: 180,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd')
    },
    {
      title: '操作',
      key: 'action',
      width: 200,
      align: 'center'
    }
  ]);

  // 当前编辑数据
  const current = ref<ArticleCategory | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 上级分类id
  const parentId = ref<number>();
  // 分类数据
  const categoryData = ref<ArticleCategory[]>([]);
  // 表格展开的行
  const expandedRowKeys = ref<number[]>([]);
  const searchText = ref('');
  const tenantId = ref<number>();
  const domain = ref<string>();

  getSiteInfo().then((data) => {
    tenantId.value = data.tenantId;
    domain.value = data.domain;
  });

  // 表格数据源
  const datasource: DatasourceFunction = ({ where }) => {
    where.title = searchText.value;
    return listArticleCategory({ ...where });
  };

  const linkTo = (item: ArticleCategory) => {
    if (item.children) {
      return false;
    }
    const url = `http://${tenantId.value}.${domain.value}${item.path}`;
    return openNew(url.replace(':id', String(item.categoryId)));
  };

  // 上移
  const moveUp = (row?: ArticleCategory) => {
    updateArticleCategory({
      categoryId: row?.categoryId,
      sortNumber: Number(row?.sortNumber) - 1
    }).then((msg) => {
      message.success(msg);
      reload();
    });
  };

  /* 数据转为树形结构 */
  const parseData = (data: ArticleCategory[]) => {
    return toTreeData({
      data: data.map((d) => {
        return { ...d, key: d.categoryId, value: d.categoryId };
      }),
      idField: 'categoryId',
      parentIdField: 'parentId'
    });
  };

  /* 表格渲染完成回调 */
  const onDone: EleProTableDone<ArticleCategory> = ({ data }) => {
    categoryData.value = data;
  };

  /* 刷新表格 */
  const reload = (where?: ArticleCategoryParam) => {
    tableRef?.value?.reload({ where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: ArticleCategory | null, id?: number) => {
    current.value = row ?? null;
    parentId.value = id;
    showEdit.value = true;
  };

  /* 删除单个 */
  const remove = (row: ArticleCategory) => {
    if (row.children?.length) {
      message.error('请先删除子节点');
      return;
    }
    const hide = messageLoading('请求中..', 0);
    removeArticleCategory(row.categoryId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 展开全部 */
  const expandAll = () => {
    let keys: number[] = [];
    eachTreeData(categoryData.value, (d) => {
      if (d.children && d.children.length && d.categoryId) {
        keys.push(d.categoryId);
      }
    });
    expandedRowKeys.value = keys;
  };

  /* 折叠全部 */
  const foldAll = () => {
    expandedRowKeys.value = [];
  };

  /* 点击展开图标时触发 */
  const onExpand = (expanded: boolean, record: ArticleCategory) => {
    if (expanded) {
      expandedRowKeys.value = [
        ...expandedRowKeys.value,
        record.categoryId as number
      ];
    } else {
      expandedRowKeys.value = expandedRowKeys.value.filter(
        (d) => d !== record.categoryId
      );
    }
  };

  /* 判断是否是目录 */
  const isDirectory = (d: ArticleCategory) => {
    return !!d.children?.length;
  };

  const onShowIndex = (row: ArticleCategory) => {
    updateArticleCategory({
      ...row,
      showIndex: row.showIndex == 1 ? 0 : 1
    }).then((msg) => {
      message.success(msg);
      reload();
    });
  };

  const onRecommend = (row: ArticleCategory) => {
    updateArticleCategory({
      ...row,
      recommend: row.recommend == 1 ? 0 : 1
    }).then((msg) => {
      message.success(msg);
      reload();
    });
  };

  /* 自定义行属性 */
  const customRow = (record: ArticleCategory) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
</script>

<script lang="ts">
  export default {
    name: 'ArticleCategory'
  };
</script>
